<template>
  <q-dialog v-if="loginDialog" v-model="visible" persistent>
    <q-card style="min-width: 350px">
      <q-card-section>
        <div class="text-h6">Zaloguj się</div>
      </q-card-section>

      <q-card-section class="q-pt-none">
        <q-input
          class="custom-input"
          label="nick lub email"
          dense
          v-model="login"
          type="text"
          autofocus
        />
        <q-input
          label="hasło"
          dense
          v-model="password"
          type="password"
          autofocus
        />
      </q-card-section>
      <q-spinner
        v-if="spinner"
        style="position: absolute; left: 50%; top: 50%"
        color="primary"
        size="3em"
      />
      <q-card-actions align="right" class="text-primary">
        <q-btn flat label="Powrót" @click="toggleLogin" />
        <q-btn flat label="Loguj" @click="handleLogin" />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>

<script setup lang="ts">
import { ref } from 'vue';
import { useQuasar } from 'quasar';

import { useRouter } from 'vue-router';

import { api } from '../boot/axios';
import eventBus from '../eventBus';
import { useUserStore } from '../stores/user';
import { useSocketStore } from '../stores/socket';

defineOptions({
  name: 'LoginDialog',
});

export interface LoginDialogProps {
  loginDialog: boolean;
  toggleLogin: () => void;
}

const props = withDefaults(defineProps<LoginDialogProps>(), {
  loginDialog: false,
});

const router = useRouter();
const userStore = useUserStore();
const { setUser, setUuid } = userStore;
const socketStore = useSocketStore();
const { setSocket } = socketStore;
const $q = useQuasar();

const login = ref<string>('');
const password = ref<string>('');
const visible = ref<boolean>(true);
const spinner = ref<boolean>(false);
function handleLogin() {
  spinner.value = true;
  api
    .post('/user/login', { login: login.value, password: password.value })
    .then(({ data }) => {
      spinner.value = false;
      if (data.status === 'OK') {
        setUser(data.user);
        setUuid(data.uuid);

        api
          .post('/message/unread', {
            uuid: data.user.uuid,
          })
          .then(({ data }) => {
            const messages = data.map(
              (el: { nick: string; number: string }) => {
                return { ...el, number: +el.number };
              }
            );
            socketStore.setUnreadMeassages(messages);
            eventBus.emit('unreceivedMessages');
          });

        setSocket('ws://localhost:3030');

        if (data.user.state === 'non-configured') {
          router.push({ path: '/config' });
        } else {
          router.push({ path: 'search' });
        }
        props.toggleLogin();
        return;
      }
      if (data.message === 'user not exist') {
        $q.notify({
          message: 'Złe dane logowania',
          html: true,
        });
      }
    });
}
</script>

<style scoped>
.dialog-font {
  font-size: 18px;
}
.custom-input .q-field__label {
  font-size: 20px !important;
}
</style>
